// ChildFrm.cpp : implementation of the CChildFrame class
//
/////////////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "resource.h"

#include "WinCapView.h"
#include "ChildFrm.h"

void CChildFrame::OnFinalMessage(HWND /*hWnd*/)
{
	delete this;
}

void CChildFrame::BuildBitmap(HWND hWnd,TCHAR* pNameString)
{
    m_view.BuildBitmap(hWnd,pNameString);
}


LRESULT CChildFrame::OnCreate(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& bHandled)
{
	m_hWndClient = m_view.Create(m_hWnd, rcDefault, NULL, WS_CHILD | WS_VISIBLE | WS_CLIPSIBLINGS | WS_CLIPCHILDREN, WS_EX_CLIENTEDGE);
	bHandled = FALSE;
	return 1;
}

LRESULT CChildFrame::OnForwardMsg(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM lParam, BOOL& /*bHandled*/)
{
	LPMSG pMsg = (LPMSG)lParam;

	if(CMDIChildWindowImpl<CChildFrame>::PreTranslateMessage(pMsg))
		return TRUE;

	return m_view.PreTranslateMessage(pMsg);
}
bool CChildFrame::IsSaved()
{
    return m_view.IsSaved();
}

void CChildFrame::SavedIt()
{
    m_view.SavedIt();
}

LRESULT CChildFrame::AskToCloseIt()
{
    #define CLOSE_IT    1
    #define NOT_CLOSED  0
    int nReturn = CLOSE_IT;
    if (m_view.IsSaved() == TRUE)
         return CLOSE_IT;
    
	int Result = MessageBox(_T("The image has not been saved. May it be saved before closing?"),_T("Unsaved image"),MB_YESNOCANCEL | MB_ICONINFORMATION);
    if (Result == IDYES)
    {
        m_view.SavedIt();
        nReturn = m_view.IsSaved() ? CLOSE_IT : NOT_CLOSED;
    }
	else if (Result == IDCANCEL)
        nReturn = NOT_CLOSED;
    return nReturn;
}


LRESULT CChildFrame::OnClose(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
	bHandled = FALSE;
	if (wParam == 0)
	{
		int nCloseit = AskToCloseIt();
		bHandled = nCloseit ? FALSE : TRUE;
	}

	return 0;
}

void CChildFrame::OnEditCopy()
{
    m_view.OnEditCopy();   
}
